# Class VulkanSemaphoreSubmitInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanSemaphoreSubmitInfo.Builder

Enclosing class:
  `VulkanSemaphoreSubmitInfo`

public static final class VulkanSemaphoreSubmitInfo.Builder extends Object
Builds instances of type `VulkanSemaphoreSubmitInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanSemaphoreSubmitInfo.Builder`
  `addAllStageMask(Iterable<VulkanPipelineStageFlag> elements)`
  Adds elements to `stageMask` set.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `addStageMask(VulkanPipelineStageFlag element)`
  Adds one element to `stageMask` set.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `addStageMask(VulkanPipelineStageFlag... elements)`
  Adds elements to `stageMask` set.
  `VulkanSemaphoreSubmitInfo`
  `build()`
  Builds a new `VulkanSemaphoreSubmitInfo`.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `from(VulkanSemaphoreSubmitInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanSemaphoreSubmitInfoType` instance.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `setDeviceIndex(long deviceIndex)`
  Initializes the value for the `deviceIndex` attribute.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `setSemaphore(VulkanSemaphoreType semaphore)`
  Initializes the value for the `semaphore` attribute.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `setStageMask(Iterable<VulkanPipelineStageFlag> elements)`
  Sets or replaces all elements for `stageMask` set.
  `final VulkanSemaphoreSubmitInfo.Builder`
  `setValue(long value)`
  Initializes the value for the `value` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanSemaphoreSubmitInfo.Builder from(VulkanSemaphoreSubmitInfoType instance)
    Fill a builder with attribute values from the provided `VulkanSemaphoreSubmitInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSemaphore

    public final VulkanSemaphoreSubmitInfo.Builder setSemaphore(VulkanSemaphoreType semaphore)
    Initializes the value for the `semaphore` attribute.
    Parameters:
      `semaphore` - The value for semaphore
    Returns:
      `this` builder for use in a chained invocation

  - ### setValue

    public final VulkanSemaphoreSubmitInfo.Builder setValue(long value)
    Initializes the value for the `value` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `value`.

    Parameters:
      `value` - The value for value
    Returns:
      `this` builder for use in a chained invocation

  - ### addStageMask

    public final VulkanSemaphoreSubmitInfo.Builder addStageMask(VulkanPipelineStageFlag element)
    Adds one element to `stageMask` set.
    Parameters:
      `element` - A stageMask element
    Returns:
      `this` builder for use in a chained invocation

  - ### addStageMask

    public final VulkanSemaphoreSubmitInfo.Builder addStageMask(VulkanPipelineStageFlag... elements)
    Adds elements to `stageMask` set.
    Parameters:
      `elements` - An array of stageMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setStageMask

    public final VulkanSemaphoreSubmitInfo.Builder setStageMask(Iterable<VulkanPipelineStageFlag> elements)
    Sets or replaces all elements for `stageMask` set.
    Parameters:
      `elements` - An iterable of stageMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllStageMask

    public final VulkanSemaphoreSubmitInfo.Builder addAllStageMask(Iterable<VulkanPipelineStageFlag> elements)
    Adds elements to `stageMask` set.
    Parameters:
      `elements` - An iterable of stageMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setDeviceIndex

    public final VulkanSemaphoreSubmitInfo.Builder setDeviceIndex(long deviceIndex)
    Initializes the value for the `deviceIndex` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `deviceIndex`.

    Parameters:
      `deviceIndex` - The value for deviceIndex
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanSemaphoreSubmitInfo build()
    Builds a new `VulkanSemaphoreSubmitInfo`.
    Returns:
      An immutable instance of VulkanSemaphoreSubmitInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing